"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const delay_1 = require("./delay");
const sfpowerkit_1 = require("../sfpowerkit");
const core_1 = require("@salesforce/core");
async function checkRetrievalStatus(conn, retrievedId, isToBeLoggedToConsole = true) {
    let metadata_result;
    while (true) {
        await conn.metadata.checkRetrieveStatus(retrievedId, function (error, result) {
            if (error) {
                return new core_1.SfdxError(error.message);
            }
            metadata_result = result;
        });
        if (metadata_result.done === "false") {
            if (isToBeLoggedToConsole)
                sfpowerkit_1.SFPowerkit.log(`Polling for Retrieval Status`, core_1.LoggerLevel.INFO);
            await delay_1.delay(5000);
        }
        else {
            //this.ux.logJson(metadata_result);
            break;
        }
    }
    return metadata_result;
}
exports.checkRetrievalStatus = checkRetrievalStatus;
//# sourceMappingURL=checkRetrievalStatus.js.map