"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
class DXProjectManifestUtils {
    constructor(projectFolder) {
        this.projectFolder = projectFolder;
    }
    removePackagesNotInDirectory() {
        //Validate projectJson Path
        let sfdxProjectManifestPath = path_1.default.join(this.projectFolder, "sfdx-project.json");
        if (!fs_extra_1.default.existsSync(sfdxProjectManifestPath))
            throw new Error(`sfdx-project.json doesn't exist at ${sfdxProjectManifestPath}`);
        // Read sfdx-projec.json
        const sfdxProjectManifest = fs_extra_1.default.readFileSync(sfdxProjectManifestPath, "utf8");
        this.sfdxProjectManifestJSON = JSON.parse(sfdxProjectManifest);
        //Filter sfdx-project.json of unwanted directories
        this.sfdxProjectManifestJSON.packageDirectories = this.sfdxProjectManifestJSON.packageDirectories.filter(el => this.isElementExists(el));
        //write back sfdx-project.json back
        fs_extra_1.default.writeJSONSync(sfdxProjectManifestPath, this.sfdxProjectManifestJSON);
    }
    isElementExists(element) {
        return fs_extra_1.default.existsSync(path_1.default.join(this.projectFolder, element.path));
    }
}
exports.DXProjectManifestUtils = DXProjectManifestUtils;
//# sourceMappingURL=dxProjectManifestUtils.js.map