"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const xml2js = require("xml2js");
const util = require("util");
const fs = require("fs-extra");
const path_1 = __importDefault(require("path"));
class XmlUtil {
    static async xmlToJSON(directory) {
        const parser = new xml2js.Parser({ explicitArray: false });
        const parseString = util.promisify(parser.parseString);
        let obj = await parseString(fs.readFileSync(path_1.default.resolve(directory)));
        return obj;
    }
    static jSONToXML(obj) {
        const builder = new xml2js.Builder();
        let xml = builder.buildObject(obj);
        return xml;
    }
}
exports.default = XmlUtil;
//# sourceMappingURL=xmlUtil.js.map